#ifndef DRCSisprime_h

#define FACTOR_PACKAGE FACTOR_LIBGMP_INT

#include "setup.h"
#include "factor.h"

/* Return values of isPrime() */
#define COMPOSITE (0)
#define PRIME (1)

/* Is n prime?  If not and a factor of n is found, set factor */
extern int isPrime(FACTOR n, FACTOR *factor);

/* Square polyInX modulo (x^r - 1) modulo n, storing result in poly2 */
extern void polySqModMod(FACTOR *polyInX, unsigned long r, FACTOR n, FACTOR *poly2);

/* Multiply polyInX into poly2 modulo (x^r - 1) modulo n, using poly3 as temporary */
extern void polyMultiplyModMod(FACTOR *polyInX, unsigned long r, FACTOR n, FACTOR *poly2, FACTOR *poly3);

#endif
